## ccextractor 0.86+ds1

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0.2)

project (CCExtractor)

option (WITH_FFMPEG "Build using FFmpeg demuxer and decoder" OFF)
option (WITH_OCR "Build with OCR (Optical Character Recognition) feature" OFF)
option (WITH_SHARING "Build with sharing and translation support" OFF)

# Version number
set (CCEXTRACTOR_VERSION_MAJOR 0)
set (CCEXTRACTOR_VERSION_MINOR 85b)

# Get project directory
get_filename_component(BASE_PROJ_DIR ../ ABSOLUTE)

# Get the latest commit hash of the working branch
IF(EXISTS "${BASE_PROJ_DIR}/.git")
    execute_process(
            COMMAND git rev-parse HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE GIT_COMMIT_HASH
            OUTPUT_STRIP_TRAILING_WHITESPACE
    )
ELSE(EXISTS "${BASE_PROJ_DIR}/.git")
    set(GIT_BRANCH "Unknown")
    set(GIT_COMMIT_HASH "Unknown")
ENDIF(EXISTS "${BASE_PROJ_DIR}/.git")

#Get the date
string(TIMESTAMP COMPILATION_DATE %Y-%m-%d)

message(STATUS "Commit : ${GIT_COMMIT_HASH}")
message(STATUS "Compilation Date: ${COMPILATION_DATE}")

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${PROJECT_SOURCE_DIR}/CCExtractorConfig.h.in"
  "${PROJECT_SOURCE_DIR}/lib_ccx/compile_info_real.h"
  )

add_definitions(-DVERSION_FILE_PRESENT -DFT2_BUILD_LIBRARY)

include_directories ("${PROJECT_SOURCE_DIR}")
include_directories ("${PROJECT_SOURCE_DIR}/lib_ccx/")
include_directories ("${PROJECT_SOURCE_DIR}/utf8proc/")
include_directories ("${PROJECT_SOURCE_DIR}/gpacmp4/")
include_directories ("${PROJECT_SOURCE_DIR}/protobuf-c/")
include_directories ("${PROJECT_SOURCE_DIR}/zvbi/")
include_directories ("${PROJECT_SOURCE_DIR}/lib_hash/")
include_directories ("${PROJECT_SOURCE_DIR}/extractors/")
include_directories ("${PROJECT_SOURCE_DIR}/wrappers/")
include_directories ("${PROJECT_SOURCE_DIR}/libpng/")
include_directories ("${PROJECT_SOURCE_DIR}/zlib/")
include_directories ("${PROJECT_SOURCE_DIR}/freetype/include/")
aux_source_directory ("${PROJECT_SOURCE_DIR}/protobuf-c/" SOURCEFILE)
aux_source_directory ("${PROJECT_SOURCE_DIR}/zvbi/" SOURCEFILE)
aux_source_directory ("${PROJECT_SOURCE_DIR}/lib_hash/" SOURCEFILE)
aux_source_directory ("${PROJECT_SOURCE_DIR}/extractors/" SOURCEFILE)
aux_source_directory ("${PROJECT_SOURCE_DIR}/wrappers/" SOURCEFILE)
aux_source_directory ("${PROJECT_SOURCE_DIR}/libpng/" SOURCEFILE)
aux_source_directory ("${PROJECT_SOURCE_DIR}/zlib/" SOURCEFILE)

set(FREETYPE_SOURCE
        ${PROJECT_SOURCE_DIR}/freetype/autofit/autofit.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftbase.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftbbox.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftbdf.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftbitmap.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftcid.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftfntfmt.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftfstype.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftgasp.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftglyph.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftgxval.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftinit.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftlcdfil.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftmm.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftotval.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftpatent.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftpfr.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftstroke.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftsynth.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftsystem.c
        ${PROJECT_SOURCE_DIR}/freetype/base/fttype1.c
        ${PROJECT_SOURCE_DIR}/freetype/base/ftwinfnt.c
        ${PROJECT_SOURCE_DIR}/freetype/bdf/bdf.c
        ${PROJECT_SOURCE_DIR}/freetype/bzip2/ftbzip2.c
        ${PROJECT_SOURCE_DIR}/freetype/cache/ftcache.c
        ${PROJECT_SOURCE_DIR}/freetype/cff/cff.c
        ${PROJECT_SOURCE_DIR}/freetype/cid/type1cid.c
        ${PROJECT_SOURCE_DIR}/freetype/gzip/ftgzip.c
        ${PROJECT_SOURCE_DIR}/freetype/lzw/ftlzw.c
        ${PROJECT_SOURCE_DIR}/freetype/pcf/pcf.c
        ${PROJECT_SOURCE_DIR}/freetype/pfr/pfr.c
        ${PROJECT_SOURCE_DIR}/freetype/psaux/psaux.c
        ${PROJECT_SOURCE_DIR}/freetype/pshinter/pshinter.c
        ${PROJECT_SOURCE_DIR}/freetype/psnames/psnames.c
        ${PROJECT_SOURCE_DIR}/freetype/raster/raster.c
        ${PROJECT_SOURCE_DIR}/freetype/sfnt/sfnt.c
        ${PROJECT_SOURCE_DIR}/freetype/smooth/smooth.c
        ${PROJECT_SOURCE_DIR}/freetype/truetype/truetype.c
        ${PROJECT_SOURCE_DIR}/freetype/type1/type1.c
        ${PROJECT_SOURCE_DIR}/freetype/type42/type42.c
        ${PROJECT_SOURCE_DIR}/freetype/winfonts/winfnt.c
        )
#Windows specific libraries and linker flags
if(WIN32)
    include_directories ("${PROJECT_SOURCE_DIR}/win_spec_incld/")
    include_directories ("${PROJECT_SOURCE_DIR}/win_iconv/")
    aux_source_directory ("${PROJECT_SOURCE_DIR}/win_iconv/" SOURCEFILE)
    set (EXTRA_LIBS ${EXTRA_LIBS} ws2_32 winmm)
else (WIN32)
    # Adding some platform specific library path
    link_directories (/opt/local/lib)
    link_directories (/usr/local/lib)
endif(WIN32)

if(MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W3 /wd4005 /wd4996")
else (MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-write-strings -g -std=gnu99")
endif(MSVC)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")
add_subdirectory (lib_ccx)

aux_source_directory (${PROJECT_SOURCE_DIR} SOURCEFILE)
set (EXTRA_LIBS ${EXTRA_LIBS} ccx)
# set (EXTRA_LIBS ${EXTRA_LIBS} m)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set (EXTRA_LIBS ${EXTRA_LIBS} iconv)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


set (EXTRA_LIBS ${EXTRA_LIBS} -lz -lm)

find_package (PkgConfig)

########################################################
# Build using FFmpeg libraries
########################################################

if (PKG_CONFIG_FOUND AND WITH_FFMPEG)

  pkg_check_modules (AVFORMAT REQUIRED libavformat)
  pkg_check_modules (AVUTIL REQUIRED libavutil)
  pkg_check_modules (AVCODEC REQUIRED libavcodec)
  pkg_check_modules (SWSCALE REQUIRED libswscale)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})

  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
endif (PKG_CONFIG_FOUND AND WITH_FFMPEG)

########################################################
# Build with OCR using leptonica and tesseract libraries
########################################################

if (PKG_CONFIG_FOUND AND WITH_OCR)

  pkg_check_modules (TESSERACT REQUIRED tesseract)
  pkg_check_modules (LEPTONICA REQUIRED lept)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_LIBRARIES})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR")
endif (PKG_CONFIG_FOUND AND WITH_OCR)

########################################################
# Build with CC sharing and translation support
########################################################

if (PKG_CONFIG_FOUND AND WITH_SHARING)

  pkg_check_modules (NANOMSG REQUIRED libnanomsg)
  set (EXTRA_LIBS ${EXTRA_LIBS} ${NANOMSG_STATIC_LIBRARIES})

  include_directories ("${PROJECT_SOURCE_DIR}/protobuf-c/")
  aux_source_directory ("${PROJECT_SOURCE_DIR}/protobuf-c/" SOURCEFILE)

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_SHARING")
endif (PKG_CONFIG_FOUND AND WITH_SHARING)

add_executable (ccextractor ${SOURCEFILE} ${FREETYPE_SOURCE})
target_link_libraries (ccextractor ${EXTRA_LIBS})
target_include_directories (ccextractor PUBLIC ${EXTRA_INCLUDES})

install (TARGETS ccextractor DESTINATION bin)

=== src/lib_ccx/CMakeLists.txt ===
cmake_policy (SET CMP0037 NEW)

if(MSVC)
    set (CMAKE_C_FLAGS "-W3 /wd4005 /wd4996")
else (MSVC)
    set (CMAKE_C_FLAGS "-Wall -g -std=gnu99")
endif(MSVC)

if(WIN32)
    add_definitions(-DWIN32)
endif(WIN32)

if (WITH_FFMPEG)
    find_package(PkgConfig)

    pkg_check_modules (AVFORMAT REQUIRED libavformat)
    pkg_check_modules (AVUTIL REQUIRED libavutil)
    pkg_check_modules (AVCODEC REQUIRED libavcodec)
    pkg_check_modules (SWSCALE REQUIRED libswscale)

    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})

    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
endif (WITH_FFMPEG)

if (WITH_OCR)
  find_package(PkgConfig)

  pkg_check_modules (TESSERACT REQUIRED tesseract)
  pkg_check_modules (LEPTONICA REQUIRED lept)

  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${TESSERACT_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${LEPTONICA_INCLUDE_DIRS})

  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_LIBRARIES})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR")
endif (WITH_OCR)

if (WITH_SHARING)
	set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_SHARING")
endif (WITH_SHARING)

aux_source_directory ("${PROJECT_SOURCE_DIR}/lib_ccx/" SOURCEFILE)
aux_source_directory ("${PROJECT_SOURCE_DIR}/gpacmp4/" SOURCEFILE)

add_library (ccx ${SOURCEFILE} ccx_dtvcc.h ccx_dtvcc.c)
target_link_libraries (ccx ${EXTRA_LIBS})
target_include_directories (ccx PUBLIC ${EXTRA_INCLUDES})

if (MINGW OR CYGWIN)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_WIN32")
endif (MINGW OR CYGWIN)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_LINUX")
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_DARWIN")
endif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


file (GLOB HeaderFiles *.h)
file (WRITE ccx.pc "prefix=${CMAKE_INSTALL_PREFIX}\n"
                  "includedir=\${prefix}/include\n"
                  "libdir=\${prefix}/lib\n\n"
                  "Name: ccx\n"
                  "Description: Closed Caption Extraction library\n"
                  "Version: 0.75\n"
                  "Cflags: -I\${includedir}/\n"
                  "Libs: -L\${libdir} -lccx -lpng\n"
                  "Libs.private: -lpng\n"
                  )

install (TARGETS ccx DESTINATION lib)
install (FILES ${HeaderFiles} DESTINATION include)
install (FILES ccx.pc DESTINATION lib/pkgconfig)

=== debian/changelog ===
ccextractor (0.86+ds1-1) unstable; urgency=medium

  * Repack new tarball without unneeded directories (windows directory and
    embedded libraries that we don't use)

 -- Sophie Brun <sophie@freexian.com>  Mon, 23 Apr 2018 16:21:41 +0200

ccextractor (0.86-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Initial release (Closes: #895514)
  * Packaging based on C. Marillat and S. Wick work (deb-multimedia.org)

  [ Raphaël Hertzog ]
  * Update maintainer field.

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 20 Apr 2018 17:46:33 +0200

=== debian/control ===
Source: ccextractor
Section: utils
Priority: optional
Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
Uploaders: Sophie Brun <sophie@freexian.com>, Raphaël Hertzog <hertzog@debian.org>
Build-Depends: debhelper (>= 11), libpng-dev, libavcodec-dev,
 libavformat-dev, libavutil-dev, libavfilter-dev, libleptonica-dev (>= 1.73~),
 libtesseract-dev (>= 4.00~), libutf8proc-dev, libcurl4-gnutls-dev, pkg-config,
 libfreetype6-dev
Standards-Version: 4.1.4
Homepage: https://www.ccextractor.org/
Vcs-Git: https://salsa.debian.org/freexian-team/ccextractor.git
Vcs-Browser: https://salsa.debian.org/freexian-team/ccextractor

Package: ccextractor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast closed captions extractor for MPEG and H264 files
 Supports DVD, HDTV transport streams, Replay TV.
 .
 Use this to create .srt (subtitles) files for your TV captures,
 have transcripts so you can edit subtitles, etc.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --sourcedirectory=linux

override_dh_auto_build:
	dh_auto_build -- ENABLE_FFMPEG=yes ENABLE_OCR=yes

override_dh_installchangelogs:
	dh_installchangelogs docs/CHANGES.TXT

override_dh_clean:
	dh_clean linux/objs/*.o linux/ccextractor src/lib_ccx/compile_info.h
	find -name *.dll | xargs -r rm
	find -name *.lib | xargs -r rm

override_dh_autoreconf:
	cd linux && ./pre-build.sh
	dh_autoreconf

## ccextractor 0.87+ds1

=== OpenBSD/Makefile ===
# $OpenBSD$

MAINTAINER = 	Marc Espie <espie@openbsd.org>
CATEGORIES =	multimedia
COMMENT =	closed caption subtitles extractor
HOMEPAGE = 	http://ccextractor.sourceforge.net/
V =		0.77
DISTFILES =	ccextractor.${V:S/.//}-src.zip
MASTER_SITES =	${MASTER_SITE_SOURCEFORGE:=ccextractor/}
DISTNAME =	ccextractor-$V
WRKDIST =	${WRKDIR}/ccextractor.$V
WRKSRC =	${WRKDIST}/src

# GPL 2.0
PERMIT_DISTFILES_CDROM =	Yes
PERMIT_PACKAGE_CDROM =		Yes
PERMIT_DISTFILES_FTP =		Yes
PERMIT_PACKAGE_FTP =		Yes

DOCDIR = 	${PREFIX}/share/doc/ccextractor
do-configure:
	ln -s ${FILESDIR}/Makefile ${WRKSRC}/Makefile

do-install:
	${INSTALL_PROGRAM} ${WRKBUILD}/ccextractor ${PREFIX}/bin
	${INSTALL_DATA_DIR} ${DOCDIR}
	for i in ${WRKDIST}/docs/*.TXT; do \
		${INSTALL_DATA} $$i ${DOCDIR}; \
	done

WANTLIB +=	c m stdc++ 

.include <bsd.port.mk>

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
 option (WITH_FFMPEG "Build using FFmpeg demuxer and decoder" OFF)
 option (WITH_OCR "Build with OCR (Optical Character Recognition) feature" OFF)
 option (WITH_SHARING "Build with sharing and translation support" OFF)
+option (WITH_HARDSUBX "Build with support for burned-in subtitles" OFF)
 
 # Version number
 set (CCEXTRACTOR_VERSION_MAJOR 0)
@@ -39,7 +40,7 @@
   "${PROJECT_SOURCE_DIR}/lib_ccx/compile_info_real.h"
   )
 
-add_definitions(-DVERSION_FILE_PRESENT -DFT2_BUILD_LIBRARY)
+add_definitions(-DVERSION_FILE_PRESENT -DFT2_BUILD_LIBRARY -DGPAC_DISABLE_VTT -DGPAC_DISABLE_OD_DUMP)
 
 include_directories ("${PROJECT_SOURCE_DIR}")
 include_directories ("${PROJECT_SOURCE_DIR}/lib_ccx/")
@@ -48,7 +49,6 @@
 include_directories ("${PROJECT_SOURCE_DIR}/protobuf-c/")
 include_directories ("${PROJECT_SOURCE_DIR}/zvbi/")
 include_directories ("${PROJECT_SOURCE_DIR}/lib_hash/")
-include_directories ("${PROJECT_SOURCE_DIR}/extractors/")
 include_directories ("${PROJECT_SOURCE_DIR}/wrappers/")
 include_directories ("${PROJECT_SOURCE_DIR}/libpng/")
 include_directories ("${PROJECT_SOURCE_DIR}/zlib/")
@@ -56,10 +56,13 @@
 aux_source_directory ("${PROJECT_SOURCE_DIR}/protobuf-c/" SOURCEFILE)
 aux_source_directory ("${PROJECT_SOURCE_DIR}/zvbi/" SOURCEFILE)
 aux_source_directory ("${PROJECT_SOURCE_DIR}/lib_hash/" SOURCEFILE)
-aux_source_directory ("${PROJECT_SOURCE_DIR}/extractors/" SOURCEFILE)
 aux_source_directory ("${PROJECT_SOURCE_DIR}/wrappers/" SOURCEFILE)
 aux_source_directory ("${PROJECT_SOURCE_DIR}/libpng/" SOURCEFILE)
 aux_source_directory ("${PROJECT_SOURCE_DIR}/zlib/" SOURCEFILE)
+
+set(UTF8PROC_SOURCE
+        ${PROJECT_SOURCE_DIR}/utf8proc/utf8proc.c
+        )
 
 set(FREETYPE_SOURCE
         ${PROJECT_SOURCE_DIR}/freetype/autofit/autofit.c
@@ -134,7 +137,7 @@
 endif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
 
 
-set (EXTRA_LIBS ${EXTRA_LIBS} -lz -lm)
+set (EXTRA_LIBS ${EXTRA_LIBS} -lz -lm -lpthread)
 
 find_package (PkgConfig)
 
@@ -143,6 +146,65 @@
 ########################################################
 
 if (PKG_CONFIG_FOUND AND WITH_FFMPEG)
+
+  pkg_check_modules (AVFORMAT REQUIRED libavformat)
+  pkg_check_modules (AVUTIL REQUIRED libavutil)
+  pkg_check_modules (AVCODEC REQUIRED libavcodec)
+  pkg_check_modules (AVFILTER REQUIRED libavfilter)
+  pkg_check_modules (SWSCALE REQUIRED libswscale)
+
+  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
+  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
+  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
+  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFILTER_LIBRARIES})
+  set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})
+
+  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
+  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
+  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
+  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFILTER_INCLUDE_DIRS})
+  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})
+
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
+endif (PKG_CONFIG_FOUND AND WITH_FFMPEG)
+
+########################################################
+# Build with OCR using leptonica and tesseract libraries
+########################################################
+
+if (PKG_CONFIG_FOUND AND WITH_OCR)
+
+  pkg_check_modules (TESSERACT REQUIRED tesseract)
+  pkg_check_modules (LEPTONICA REQUIRED lept)
+
+  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_LIBRARIES})
+  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_LIBRARIES})
+
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR")
+endif (PKG_CONFIG_FOUND AND WITH_OCR)
+
+########################################################
+# Build with CC sharing and translation support
+########################################################
+
+if (PKG_CONFIG_FOUND AND WITH_SHARING)
+
+  pkg_check_modules (NANOMSG REQUIRED libnanomsg)
+  set (EXTRA_LIBS ${EXTRA_LIBS} ${NANOMSG_STATIC_LIBRARIES})
+
+  include_directories ("${PROJECT_SOURCE_DIR}/protobuf-c/")
+  aux_source_directory ("${PROJECT_SOURCE_DIR}/protobuf-c/" SOURCEFILE)
+
+  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_SHARING")
+endif (PKG_CONFIG_FOUND AND WITH_SHARING)
+
+########################################################
+# Build for hardsubx using avformat, avutil, avcodec and
+# swscale
+########################################################
+
+if (PKG_CONFIG_FOUND AND WITH_HARDSUBX)
 
   pkg_check_modules (AVFORMAT REQUIRED libavformat)
   pkg_check_modules (AVUTIL REQUIRED libavutil)
@@ -159,41 +221,10 @@
   set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
   set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})
 
-  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
   set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
-endif (PKG_CONFIG_FOUND AND WITH_FFMPEG)
-
-########################################################
-# Build with OCR using leptonica and tesseract libraries
-########################################################
-
-if (PKG_CONFIG_FOUND AND WITH_OCR)
-
-  pkg_check_modules (TESSERACT REQUIRED tesseract)
-  pkg_check_modules (LEPTONICA REQUIRED lept)
-
-  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_LIBRARIES})
-  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_LIBRARIES})
-
-  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR")
-endif (PKG_CONFIG_FOUND AND WITH_OCR)
-
-########################################################
-# Build with CC sharing and translation support
-########################################################
-
-if (PKG_CONFIG_FOUND AND WITH_SHARING)
-
-  pkg_check_modules (NANOMSG REQUIRED libnanomsg)
-  set (EXTRA_LIBS ${EXTRA_LIBS} ${NANOMSG_STATIC_LIBRARIES})
-
-  include_directories ("${PROJECT_SOURCE_DIR}/protobuf-c/")
-  aux_source_directory ("${PROJECT_SOURCE_DIR}/protobuf-c/" SOURCEFILE)
-
-  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_SHARING")
-endif (PKG_CONFIG_FOUND AND WITH_SHARING)
-
-add_executable (ccextractor ${SOURCEFILE} ${FREETYPE_SOURCE})
+endif (PKG_CONFIG_FOUND AND WITH_HARDSUBX)
+
+add_executable (ccextractor ${SOURCEFILE} ${FREETYPE_SOURCE} ${UTF8PROC_SOURCE})
 target_link_libraries (ccextractor ${EXTRA_LIBS})
 target_include_directories (ccextractor PUBLIC ${EXTRA_INCLUDES})

=== tests/Makefile ===
SHELL = /bin/sh

CC=gcc
# SYS := $(shell gcc -dumpmachine)
CFLAGS=-O0 -std=gnu99 -D ENABLE_OCR -g -ggdb -rdynamic
#-Q -da -v

# enable COVERAGE
# CFLAGS+=-fprofile-arcs -ftest-coverage

# add debug flag
ifdef DEBUG
CFLAGS+=-DDEBUG
endif

#ALL_FLAGS = -Wno-write-strings -D_FILE_OFFSET_BITS=64 -DVERSION_FILE_PRESENT
LDFLAGS=-lm -g

CFLAGS+=$(shell pkg-config --cflags check)
LDFLAGS+=$(shell pkg-config --libs check)

# TODO: need to rewrite this. Need new way to load sources for testing
OBJS=$(filter-out ../linux/objs/ccextractor.o, $(wildcard ../linux/objs/*.o))

SRC_SUITE=$(wildcard *_suite.c)
OBJ_SUITE=$(patsubst %_suite.c, %_suite.o, $(SRC_SUITE))

OBJS+=$(OBJ_SUITE)

all: clean test

%.o: %.c
	# explicit output name :  -o $@
	$(CC) -c $(ALL_FLAGS) $(CFLAGS) $<

runtest: $(OBJS)
	@echo "+----------------------------------------------+"
	@echo "|                 BUILD TESTS                  |"
	@echo "+----------------------------------------------+"
	$(CC) -c $(ALL_FLAGS) $(CFLAGS) $@.c
	$(CC) $@.o $^ $(ALL_FLAGS) $(CFLAGS) $(LDFLAGS) -o $@

.PHONY: test
test: runtest
	@echo "+----------------------------------------------+"
	@echo "|                 START TESTS                  |"
	@echo "+----------------------------------------------+"
	./runtest

.PHONY: clean
clean:
	rm runtest || true
	rm *.o || true
	# coverage info
	rm *.gcda || true
	rm *.gcno || true
	# debug info
	rm *.c.* || true

=== src/lib_ccx/CMakeLists.txt ===
--- 
+++ 
@@ -16,16 +16,19 @@
     pkg_check_modules (AVFORMAT REQUIRED libavformat)
     pkg_check_modules (AVUTIL REQUIRED libavutil)
     pkg_check_modules (AVCODEC REQUIRED libavcodec)
+    pkg_check_modules (AVFILTER REQUIRED libavfilter)
     pkg_check_modules (SWSCALE REQUIRED libswscale)
 
     set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
     set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
     set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
+    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFILTER_LIBRARIES})
     set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})
 
     set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
     set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
     set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
+    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFILTER_INCLUDE_DIRS})
     set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})
 
   set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
@@ -58,6 +61,27 @@
 target_link_libraries (ccx ${EXTRA_LIBS})
 target_include_directories (ccx PUBLIC ${EXTRA_INCLUDES})
 
+if (WITH_HARDSUBX)
+    find_package(PkgConfig)
+
+    pkg_check_modules (AVFORMAT REQUIRED libavformat)
+    pkg_check_modules (AVUTIL REQUIRED libavutil)
+    pkg_check_modules (AVCODEC REQUIRED libavcodec)
+    pkg_check_modules (SWSCALE REQUIRED libswscale)
+
+    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
+    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
+    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
+    set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})
+
+    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
+    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
+    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
+    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})
+
+    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
+endif (WITH_HARDSUBX)
+
 if (MINGW OR CYGWIN)
     set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_WIN32")
 endif (MINGW OR CYGWIN)

=== debian/changelog ===
ccextractor (0.87+ds1-1) unstable; urgency=medium

  [ Corey Wright ]
  * Enable OCR and hard subtitle extraction through configure options.
    The environment variables passed to make are no longer used.
    (Closes: #914311)

  [ Raphaël Hertzog ]
  * New upstream version 0.87+ds1
  * Update patches for new upstream version
  * Add extra include statement for tesseract headers
  * Update my maintainer email

 -- Raphaël Hertzog <raphael@freexian.com>  Fri, 30 Nov 2018 11:45:16 +0100

ccextractor (0.86+ds1-2) unstable; urgency=medium

  * Add a patch to make the build reproducible (Closes: #896867, thanks to
    Chris Lamb)
  * Bump Standards-Version to 4.2.1

 -- Sophie Brun <sophie@freexian.com>  Wed, 05 Sep 2018 11:14:58 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: utils
 Priority: optional
 Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
-Uploaders: Sophie Brun <sophie@freexian.com>, Raphaël Hertzog <hertzog@debian.org>
+Uploaders: Sophie Brun <sophie@freexian.com>, Raphaël Hertzog <raphael@freexian.com>
 Build-Depends: debhelper (>= 11), libpng-dev, libavcodec-dev,
  libavformat-dev, libavutil-dev, libavfilter-dev, libleptonica-dev (>= 1.73~),
  libtesseract-dev (>= 4.00~), libutf8proc-dev, libcurl4-gnutls-dev, pkg-config,
  libfreetype6-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://www.ccextractor.org/
 Vcs-Git: https://salsa.debian.org/freexian-team/ccextractor.git
 Vcs-Browser: https://salsa.debian.org/freexian-team/ccextractor

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --sourcedirectory=linux

override_dh_auto_configure:
	dh_auto_configure -- --enable-ocr --enable-hardsubx

override_dh_installchangelogs:
	dh_installchangelogs docs/CHANGES.TXT

override_dh_clean:
	dh_clean linux/objs/*.o linux/ccextractor
	find -name *.dll | xargs -r rm
	find -name *.lib | xargs -r rm

override_dh_autoreconf:
	cd linux && ./pre-build.sh
	dh_autoreconf

## ccextractor 0.88

=== debian/changelog ===
ccextractor (0.88-0mx17+1) mx; urgency=medium

  * Rebuild for MX-17/18

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Thu, 26 Dec 2019 15:51:18 -0800

ccextractor (0.88-0mx19+1) mx; urgency=medium

  * Rebuild for MX-19.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Thu, 26 Dec 2019 15:31:09 -0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ccextractor
 Section: utils
 Priority: optional
-Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
 Uploaders: Sophie Brun <sophie@freexian.com>, Raphaël Hertzog <raphael@freexian.com>
 Build-Depends: debhelper (>= 11), libpng-dev, libavcodec-dev,
  libavformat-dev, libavutil-dev, libavfilter-dev, libleptonica-dev (>= 1.73~),

=== debian/rules ===
--- 
+++ 
@@ -19,3 +19,7 @@
 override_dh_autoreconf:
 	cd linux && ./pre-build.sh
 	dh_autoreconf
+
+override_dh_strip:
+	dh_strip -a --no-automatic-dbgsym
+

## ccextractor 0.88+ds1

=== OpenBSD/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 CATEGORIES =	multimedia
 COMMENT =	closed caption subtitles extractor
 HOMEPAGE = 	http://ccextractor.sourceforge.net/
-V =		0.77
+V =		0.88
 DISTFILES =	ccextractor.${V:S/.//}-src.zip
 MASTER_SITES =	${MASTER_SITE_SOURCEFORGE:=ccextractor/}
 DISTNAME =	ccextractor-$V

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,10 @@
   )
 
 add_definitions(-DVERSION_FILE_PRESENT -DFT2_BUILD_LIBRARY -DGPAC_DISABLE_VTT -DGPAC_DISABLE_OD_DUMP)
+
+if(CMAKE_SIZEOF_VOID_P EQUAL 8)
+  add_definitions(-DGPAC_64_BITS)
+endif()
 
 include_directories ("${PROJECT_SOURCE_DIR}")
 include_directories ("${PROJECT_SOURCE_DIR}/lib_ccx/")

=== debian/changelog ===
ccextractor (0.88+ds1-1) unstable; urgency=medium

  [ Sebastien Delafond ]
  * Use gcc10
  * New upstream version 0.88+ds1
  * Fix multiple definitions with new -fno-common default in GCC 10
    (Closes: #957071)
  
  [ Debian Janitor ]  
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  
 -- Sebastien Delafond <seb@debian.org>  Fri, 07 Aug 2020 10:45:13 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: ccextractor
 Section: utils
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
+Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
 Uploaders: Sophie Brun <sophie@freexian.com>, Raphaël Hertzog <raphael@freexian.com>
-Build-Depends: debhelper (>= 11), libpng-dev, libavcodec-dev,
+Build-Depends: debhelper-compat (= 12), libpng-dev, libavcodec-dev,
  libavformat-dev, libavutil-dev, libavfilter-dev, libleptonica-dev (>= 1.73~),
  libtesseract-dev (>= 4.00~), libutf8proc-dev, libcurl4-gnutls-dev, pkg-config,
- libfreetype6-dev
+ libfreetype6-dev, gcc-10
 Standards-Version: 4.2.1
 Homepage: https://www.ccextractor.org/
 Vcs-Git: https://salsa.debian.org/freexian-team/ccextractor.git

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ccextractor-$1.tar.gz%,dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
   https://github.com/CCExtractor/ccextractor/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## ccextractor 0.93%2Bds2

=== debian/changelog ===
ccextractor (0.93+ds2-2) unstable; urgency=medium

  * Team upload.
  * Patch lib_ccx/params.c to provide support for gpac 2.0
    (Closes: #1006549)
  * Update d.copyright

 -- Neil Williams <codehelp@debian.org>  Wed, 16 Mar 2022 08:36:38 +0000

ccextractor (0.93+ds2-1) unstable; urgency=medium

  * Team upload

  * Repacked upstream release to drop embedded gpac sources.
  * Use system gpac libraries (Closes: #994754)
    - CVE-2021-33362 CVE-2021-32440 CVE-2021-32139
    - CVE-2021-32137 CVE-2021-32134 CVE-2021-31260
    - CVE-2021-31258 CVE-2021-30014 CVE-2021-28300
    - CVE-2021-21852 CVE-2020-35981 CVE-2020-35980
    - CVE-2020-24829 CVE-2020-19751 CVE-2020-6631
    - CVE-2020-6630  CVE-2019-20208 CVE-2019-20171
    - CVE-2019-20170 CVE-2019-20162 CVE-2019-20161
    - CVE-2019-13618 CVE-2019-12483 CVE-2019-12482
    - CVE-2019-12481 CVE-2018-21015

 -- Neil Williams <codehelp@debian.org>  Mon, 20 Sep 2021 08:57:51 +0100

ccextractor (0.93+ds1-1) unstable; urgency=medium

  * Team upload

  * New upstream release.
  * Update ds file removals for upstream path changes
  * Includes fix for segmentation fault with empty file and
    -out=report option (Closes: #908914)

 -- Neil Williams <codehelp@debian.org>  Thu, 16 Sep 2021 15:28:45 +0100

## ccextractor 0.93+ds2

=== OpenBSD/Makefile ===
--- 
+++ 
@@ -3,8 +3,8 @@
 MAINTAINER = 	Marc Espie <espie@openbsd.org>
 CATEGORIES =	multimedia
 COMMENT =	closed caption subtitles extractor
-HOMEPAGE = 	http://ccextractor.sourceforge.net/
-V =		0.88
+HOMEPAGE = 	https://ccextractor.org
+V =		0.93
 DISTFILES =	ccextractor.${V:S/.//}-src.zip
 MASTER_SITES =	${MASTER_SITE_SOURCEFORGE:=ccextractor/}
 DISTNAME =	ccextractor-$V

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0.2)

project (CCExtractor)

option (WITH_FFMPEG "Build using FFmpeg demuxer and decoder" OFF)
option (WITH_OCR "Build with OCR (Optical Character Recognition) feature" OFF)
option (WITH_SHARING "Build with sharing and translation support" OFF)
option (WITH_HARDSUBX "Build with support for burned-in subtitles" OFF)
option (WITH_RUST "Build with Rust library" OFF)

# Version number
set (CCEXTRACTOR_VERSION_MAJOR 0)
set (CCEXTRACTOR_VERSION_MINOR 89)

# Get project directory
get_filename_component(BASE_PROJ_DIR ../ ABSOLUTE)

# Get the latest commit hash of the working branch
IF(EXISTS "${BASE_PROJ_DIR}/.git")
    execute_process(
            COMMAND git rev-parse HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE GIT_COMMIT_HASH
            OUTPUT_STRIP_TRAILING_WHITESPACE
    )
ELSE(EXISTS "${BASE_PROJ_DIR}/.git")
    set(GIT_BRANCH "Unknown")
    set(GIT_COMMIT_HASH "Unknown")
ENDIF(EXISTS "${BASE_PROJ_DIR}/.git")

#Get the date
string(TIMESTAMP COMPILATION_DATE %Y-%m-%d)

message(STATUS "Commit : ${GIT_COMMIT_HASH}")
message(STATUS "Compilation Date: ${COMPILATION_DATE}")

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${PROJECT_SOURCE_DIR}/CCExtractorConfig.h.in"
  "${PROJECT_SOURCE_DIR}/lib_ccx/compile_info_real.h"
  )

add_definitions(-DVERSION_FILE_PRESENT -DFT2_BUILD_LIBRARY -DGPAC_DISABLE_VTT -DGPAC_DISABLE_OD_DUMP -DGPAC_DISABLE_REMOTERY -DNO_GZIP -DGPAC_HAVE_CONFIG_H)

if(UNIX)
  add_definitions(-DGPAC_CONFIG_LINUX)
endif(UNIX)

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  add_definitions(-DGPAC_64_BITS)
endif()

include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_SOURCE_DIR}/lib_ccx)
include_directories(${PROJECT_SOURCE_DIR}/lib_ccx/zvbi)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/gpacmp4)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/protobuf-c)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/lib_hash)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/libpng)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/zlib)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/freetype/include)
aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/gpacmp4/ SOURCEFILE)
aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/lib_hash/ SOURCEFILE)
aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/libpng/ SOURCEFILE)
aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/protobuf-c/ SOURCEFILE)
aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/zlib/ SOURCEFILE)
aux_source_directory(${PROJECT_SOURCE_DIR}/lib_ccx/zvbi/ SOURCEFILE)

set(UTF8PROC_SOURCE ${PROJECT_SOURCE_DIR}/thirdparty/utf8proc/utf8proc.c)

set(FREETYPE_SOURCE
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/autofit/autofit.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftbase.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftbbox.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftbdf.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftbitmap.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftcid.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftfntfmt.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftfstype.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftgasp.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftglyph.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftgxval.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftinit.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftlcdfil.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftmm.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftotval.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftpatent.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftpfr.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftstroke.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftsynth.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftsystem.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/fttype1.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftwinfnt.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/bdf/bdf.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/bzip2/ftbzip2.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/cache/ftcache.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/cff/cff.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/cid/type1cid.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/gzip/ftgzip.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/lzw/ftlzw.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/pcf/pcf.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/pfr/pfr.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/psaux/psaux.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/pshinter/pshinter.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/psnames/psnames.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/raster/raster.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/sfnt/sfnt.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/smooth/smooth.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/truetype/truetype.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/type1/type1.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/type42/type42.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/winfonts/winfnt.c
        )
#Windows specific libraries and linker flags
if(WIN32)
    include_directories ("${PROJECT_SOURCE_DIR}/thirdparty/win_spec_incld/")
    include_directories ("${PROJECT_SOURCE_DIR}/thirdparty/win_iconv/")
    aux_source_directory ("${PROJECT_SOURCE_DIR}/thirdparty/win_iconv/" SOURCEFILE)
    set (EXTRA_LIBS ${EXTRA_LIBS} ws2_32 winmm)
else (WIN32)
    # Adding some platform specific library path
    link_directories (/opt/local/lib)
    link_directories (/usr/local/lib)
endif(WIN32)

if(MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W3 /wd4005 /wd4996")
else (MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-write-strings -g -std=gnu99")
endif(MSVC)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")
add_subdirectory (lib_ccx)

aux_source_directory(${PROJECT_SOURCE_DIR} SOURCEFILE)
set (EXTRA_LIBS ${EXTRA_LIBS} ccx)
# set (EXTRA_LIBS ${EXTRA_LIBS} m)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set (EXTRA_LIBS ${EXTRA_LIBS} iconv)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


set (EXTRA_LIBS ${EXTRA_LIBS} -lm -lpthread -ldl)

find_package (PkgConfig)

########################################################
# Build using FFmpeg libraries
########################################################

if (PKG_CONFIG_FOUND AND WITH_FFMPEG)

  pkg_check_modules (AVFORMAT REQUIRED libavformat)
  pkg_check_modules (AVUTIL REQUIRED libavutil)
  pkg_check_modules (AVCODEC REQUIRED libavcodec)
  pkg_check_modules (AVFILTER REQUIRED libavfilter)
  pkg_check_modules (SWSCALE REQUIRED libswscale)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFILTER_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})

  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFILTER_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
endif (PKG_CONFIG_FOUND AND WITH_FFMPEG)

########################################################
# Build with OCR using leptonica and tesseract libraries
########################################################

if (PKG_CONFIG_FOUND AND WITH_OCR)

  pkg_check_modules (TESSERACT REQUIRED tesseract)
  pkg_check_modules (LEPTONICA REQUIRED lept)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_LIBRARIES})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR")
endif (PKG_CONFIG_FOUND AND WITH_OCR)

########################################################
# Build with CC sharing and translation support
########################################################

if (PKG_CONFIG_FOUND AND WITH_SHARING)

  pkg_check_modules (NANOMSG REQUIRED libnanomsg)
  set (EXTRA_LIBS ${EXTRA_LIBS} ${NANOMSG_STATIC_LIBRARIES})

  include_directories ("${PROJECT_SOURCE_DIR}/thirdparty/protobuf-c/")
  aux_source_directory ("${PROJECT_SOURCE_DIR}/thirdparty/protobuf-c/" SOURCEFILE)

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_SHARING")
endif (PKG_CONFIG_FOUND AND WITH_SHARING)

########################################################
# Build for hardsubx using avformat, avutil, avcodec and
# swscale
########################################################

if (PKG_CONFIG_FOUND AND WITH_HARDSUBX)

  pkg_check_modules (AVFORMAT REQUIRED libavformat)
  pkg_check_modules (AVUTIL REQUIRED libavutil)
  pkg_check_modules (AVCODEC REQUIRED libavcodec)
  pkg_check_modules (SWSCALE REQUIRED libswscale)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})

  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
endif (PKG_CONFIG_FOUND AND WITH_HARDSUBX)

add_executable (ccextractor ${SOURCEFILE} ${FREETYPE_SOURCE} ${UTF8PROC_SOURCE})

########################################################
# Build with Rust library
########################################################

if (PKG_CONFIG_FOUND AND WITH_RUST)
  add_subdirectory (rust)
  get_target_property(RUST_LIB ccx_rust LOCATION)
  set (EXTRA_LIBS ${EXTRA_LIBS} ${RUST_LIB})
  add_dependencies(ccextractor ccx_rust)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_RUST")
endif (PKG_CONFIG_FOUND AND WITH_RUST)

target_link_libraries (ccextractor ${EXTRA_LIBS})
target_include_directories (ccextractor PUBLIC ${EXTRA_INCLUDES})

install (TARGETS ccextractor DESTINATION bin)

=== src/lib_ccx/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 if(MSVC)
     set (CMAKE_C_FLAGS "-W3 /wd4005 /wd4996")
 else (MSVC)
-    set (CMAKE_C_FLAGS "-Wall -g -std=gnu99")
+    set (CMAKE_C_FLAGS "-Wall -Wno-pointer-sign -g -std=gnu99")
 endif(MSVC)
 
 if(WIN32)
@@ -57,7 +57,7 @@
 aux_source_directory ("${PROJECT_SOURCE_DIR}/lib_ccx/" SOURCEFILE)
 aux_source_directory ("${PROJECT_SOURCE_DIR}/gpacmp4/" SOURCEFILE)
 
-add_library (ccx ${SOURCEFILE} ccx_dtvcc.h ccx_dtvcc.c)
+add_library (ccx ${SOURCEFILE} ccx_dtvcc.h ccx_dtvcc.c ccx_encoders_mcc.c ccx_encoders_mcc.h)
 target_link_libraries (ccx ${EXTRA_LIBS})
 target_include_directories (ccx PUBLIC ${EXTRA_INCLUDES})
 
@@ -86,6 +86,10 @@
     set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_WIN32")
 endif (MINGW OR CYGWIN)
 
+if (WITH_RUST)
+    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_RUST")
+endif (WITH_RUST)
+
 if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
     set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_LINUX")
 endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

=== src/rust/CMakeLists.txt ===
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CARGO_CMD cargo build)
    set(TARGET_DIR "debug")
else ()
    set(CARGO_CMD cargo build --release)
    set(TARGET_DIR "release")
endif ()

set(CCX_RUST_SO "${CMAKE_CURRENT_BINARY_DIR}/${TARGET_DIR}/libccx_rust.so")

add_custom_target(ccx_rust ALL
    COMMENT "Compiling ccx_rust module"
    COMMAND CARGO_TARGET_DIR=${CMAKE_CURRENT_BINARY_DIR} ${CARGO_CMD} 
    COMMAND cp ${CCX_RUST_SO} ${CMAKE_CURRENT_BINARY_DIR}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
set_target_properties(ccx_rust PROPERTIES LOCATION ${CCX_RUST_SO})

add_test(NAME ccx_rust_test 
    COMMAND cargo test
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== debian/control ===
Source: ccextractor
Section: utils
Priority: optional
Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
Uploaders: Sophie Brun <sophie@freexian.com>, Raphaël Hertzog <raphael@freexian.com>
Build-Depends: debhelper-compat (= 13), libpng-dev, libavcodec-dev,
 libavformat-dev, libavutil-dev, libavfilter-dev, libleptonica-dev,
 libtesseract-dev, libutf8proc-dev, libcurl4-gnutls-dev, pkg-config,
 libfreetype6-dev, libgpac-dev, gcc-10
Standards-Version: 4.6.0
Homepage: https://www.ccextractor.org/
Vcs-Git: https://salsa.debian.org/freexian-team/packages/ccextractor.git
Vcs-Browser: https://salsa.debian.org/freexian-team/packages/ccextractor

Package: ccextractor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast closed captions extractor for MPEG and H264 files
 Supports DVD, HDTV transport streams, Replay TV.
 .
 Use this to create .srt (subtitles) files for your TV captures,
 have transcripts so you can edit subtitles, etc.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export CC = gcc-10
+export CXX = g++-10
 
 %:
 	dh $@ --sourcedirectory=linux
@@ -19,7 +21,3 @@
 override_dh_autoreconf:
 	cd linux && ./pre-build.sh
 	dh_autoreconf
-
-override_dh_strip:
-	dh_strip -a --no-automatic-dbgsym
-

## ccextractor 0.94%2Bds1

=== debian/changelog ===
ccextractor (0.94+ds1-3build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:37:06 +1100

ccextractor (0.94+ds1-3build2) noble; urgency=medium

  * No-change rebuild against libgpac12t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 02:22:30 +0000

ccextractor (0.94+ds1-3build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:12:24 +0000

ccextractor (0.94+ds1-3) unstable; urgency=medium

  * Team upload.
  * Add patch to drop bashism in the configure script.
    (Closes: #998781)

 -- Utkarsh Gupta <utkarsh@debian.org>  Thu, 23 Nov 2023 14:21:54 +0000

ccextractor (0.94+ds1-2) unstable; urgency=medium

  * Team upload.
  * Add patch fix FTBFS with ffmpeg 5.0 5 and tesseract 5.0
    compatibility. (Closes: #1004581)

 -- Utkarsh Gupta <utkarsh@debian.org>  Wed, 21 Jun 2023 02:56:12 +0530

ccextractor (0.94+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Disable rust due to missing iconv crate - minimal rust code in
    package.
  * Update d.watch to use repack

 -- Neil Williams <codehelp@debian.org>  Mon, 04 Apr 2022 11:41:48 +0100
